/*
 * pcidump.c
 *
 * original code: SASANO Takayoshi
 * --- public domain, no warranty.
 */
#include <basic.h>
#include <bstdio.h>
#include <errcode.h>
#include <driver/pcat/pci.h>

/* $B%a%$%s!&(BPCI$B%G%P%$%9$N8!:w(B */
EXPORT	W	main(W argc, TC *argv[])
{
	W	caddr, device;
	UW	vendor, class, subvendor;

	device = 0;

	for (caddr = 0; caddr <= 0xffff; caddr++) {
		/* $B%Y%s%@(BID$B!&%G%P%$%9(BID$B$N<hF@(B */
		vendor = inPciConfW(caddr, PCR_VENDORID);

		/* $BB8:_$7$J$$>l9g$O%9%-%C%W(B */
		if (vendor == 0xffffffff) continue;

		/* $B%j%S%8%g%s!&%/%i%9$N<hF@(B */
		class     = inPciConfW(caddr, PCR_REVID);
		subvendor = inPciConfW(caddr, PCR_SUBVENDID);

		printf("[%4x] Vend:%04x Dev:%04x Rev:%02x Class:%04x:%02x ",
		       (UH)caddr, (UH)(vendor), (UH)(vendor >> 16),
		       (UB)class, (UH)(class >> 16), (UB)(class >> 8));

		printf("sVen:%04x sDev:%04x\n",
		       (UH)subvendor, (UH)(subvendor >> 16));

		device++;
	}

	printf("Total %d Devices/Func\n", device);

	return ER_OK;
}
